conf_reg(rc.file_changed_interval,            scalar, RND_CFN_REAL,    "rc",                     "file_changed_interval",  "how often to check if the file has changed on the disk (in seconds); 0 or negative means no check at all", 0)
conf_reg(rc.backup_interval,                  scalar, RND_CFN_INTEGER, "rc",                     "backup_interval",        "time between two backups in seconds; 0 means disabled (no backups)", 0)
conf_reg(rc.library_search_paths,             scalar, RND_CFN_LIST,    "rc",                     "library_search_paths",   "ordered list of paths that are each recursively searched for symbol files", 0)
conf_reg(rc.hlibrary_search_paths,            scalar, RND_CFN_LIST,    "rc",                     "hlibrary_search_paths",  "ordered list of paths that are each recursively searched for external hierarchic child sheets", 0)
conf_reg(rc.emergency_name,                   scalar, RND_CFN_STRING,  "rc",                     "emergency_name",         "file name template for emergency save anonymous .sch files (when sch-rnd crashes); optional field: first %ld --> pid, second %ld --> sheet uid; must be shorter than 240 characters. Don't do emergency save if this item is empty.", 0)
conf_reg(rc.backup_name,                      scalar, RND_CFN_STRING,  "rc",                     "backup_name",            "file name template for periodic backup of board files; optional fields (the usual % substitutions work)", 0)
conf_reg(rc.keep_save_backups,                scalar, RND_CFN_BOOLEAN, "rc",                     "keep_save_backups",      "TODO: a copy is made before a save operation overwrites an existing file; if this setting is true, keep the copy even after a successful save", 0)
conf_reg(rc.default_sheet_file,               scalar, RND_CFN_LIST,    "rc",                     "default_sheet_file",     "ordered list of paths to load default sheet from when a new sheet needs to be created", 0)
conf_reg(rc.font_dirs,                        scalar, RND_CFN_LIST,    "rc",                     "font_dirs",              "Unordered list of directories to pick up Ringdove fonts from", 0)
conf_reg(rc.silently_create_on_load,          scalar, RND_CFN_BOOLEAN, "rc",                     "silently_create_on_load", "TODO: do not generate an error message if the board does not exist on load from command line argument, silently create it in memory", 0)
conf_reg(rc.debug.draw_text_xform,            scalar, RND_CFN_BOOLEAN, "rc/debug",               "draw_text_xform",        "draw arrows representing xform matrix of text object's parent", 0)
conf_reg(rc.debug.draw_arc_bbox,              scalar, RND_CFN_BOOLEAN, "rc/debug",               "draw_arc_bbox",          "draw an 1 pixel line on every arc object bounding box", 0)
conf_reg(rc.path.prefix,                      scalar, RND_CFN_STRING,  "rc/path",                "prefix",                 "e.g. /usr/local", 0)
conf_reg(rc.path.lib,                         scalar, RND_CFN_STRING,  "rc/path",                "lib",                    "e.g. /usr/lib/sch-rnd", 0)
conf_reg(rc.path.bin,                         scalar, RND_CFN_STRING,  "rc/path",                "bin",                    "e.g. /usr/bin", 0)
conf_reg(rc.path.share,                       scalar, RND_CFN_STRING,  "rc/path",                "share",                  "e.g. /usr/share/sch-rnd", 0)
conf_reg(rc.path.fontdir,                     scalar, RND_CFN_STRING,  "rc/path",                "fontdir",                "rnd fonts are searched in these dirs", 0)
conf_reg(rc.path.design,                      scalar, RND_CFN_STRING,  "rc/path",                "design",                 "directory path of the current design, or <invalid> if the current design doesn't have a file name yet", 0)
conf_reg(rc.path.dotdir,                      scalar, RND_CFN_STRING,  "rc/path",                "dotdir",                 "user's config dir, normally ~/.sch-rnd", 0)
conf_reg(editor.click_time,                   scalar, RND_CFN_INTEGER, "editor",                 "click_time",             "default time for click expiration, in ms", 0)
conf_reg(editor.edit_time,                    scalar, RND_CFN_INTEGER, "editor",                 "edit_time",              "default time to wait in dialog boxes after declaring editing finished and auto-applying changes, in ms", 0)
conf_reg(editor.autocomp_time,                scalar, RND_CFN_INTEGER, "editor",                 "autocomp_time",          "default time to wait after last change before running autocompile, in ms; <=0 means immediate; shall be set in the user config (not accepted from project or design)", 0)
conf_reg(editor.autocomp,                     scalar, RND_CFN_BOOLEAN, "editor",                 "autocomp",               "whether enable autocomp on startup; shall be set in the user config (not accepted from project or design)", 0)
conf_reg(editor.save_in_tmp,                  scalar, RND_CFN_BOOLEAN, "editor",                 "save_in_tmp",            "emergency save unsaved sheet data (despite the user clicks don't save) when user quits sch-rnd. Does not affect the on-crash emergency save.", 0)
conf_reg(editor.line_refraction,              scalar, RND_CFN_BOOLEAN, "editor",                 "line_refraction",        "<line_refraction>", 0)
conf_reg(editor.line_cont,                    scalar, RND_CFN_BOOLEAN, "editor",                 "line_cont",              "<line_cont>", 0)
conf_reg(editor.lock_floaters,                scalar, RND_CFN_BOOLEAN, "editor",                 "lock_floaters",          "lock down floaters so they can not be moved or selected", 0)
conf_reg(editor.only_floaters,                scalar, RND_CFN_BOOLEAN, "editor",                 "only_floaters",          "lock down everything else but floaters so only floater objects can be moved or selected", 0)
conf_reg(editor.paste_to_local_lib,           scalar, RND_CFN_BOOLEAN, "editor",                 "paste_to_local_lib",     "automatically paste library entries from buffer to sheet-local library and use references from the sheet instead of heavy copies", 0)
conf_reg(editor.rubber_band_mode,             scalar, RND_CFN_BOOLEAN, "editor",                 "rubber_band_mode",       "moving wires try to keep their connections to other wires", 0)
conf_reg(editor.rubber_band_ortho,            scalar, RND_CFN_BOOLEAN, "editor",                 "rubber_band_ortho",      "add orthogonal (90 degree) wire line segments when rubber banding", 0)
conf_reg(editor.buffer_number,                scalar, RND_CFN_INTEGER, "editor",                 "buffer_number",          "index of the current buffer", 0)
conf_reg(editor.selection.disable_negative,   scalar, RND_CFN_BOOLEAN, "editor/selection",       "disable_negative",       "selection box behaviour: disable the negative-direction selection - any selection box will select only what's fully within the box", 0)
conf_reg(editor.selection.symmetric_negative, scalar, RND_CFN_BOOLEAN, "editor/selection",       "symmetric_negative",     "selection box behaviour: when set, the selection direction is considered negative only if the box has negative size in the X direction", 0)
conf_reg(editor.style.tool_circle_stroke,     scalar, RND_CFN_LIST,    "editor/style",           "tool_circle_stroke",     "pen preference for the circle tool; pick the first existing pen or if none existing the first item", 0)
conf_reg(editor.style.tool_line_stroke,       scalar, RND_CFN_LIST,    "editor/style",           "tool_line_stroke",       "pen preference for the line tool; pick the first existing pen or if none existing the first item", 0)
conf_reg(editor.style.tool_text_stroke,       scalar, RND_CFN_LIST,    "editor/style",           "tool_text_stroke",       "pen preference for the text tool; pick the first existing pen or if none existing the first item", 0)
conf_reg(editor.style.tool_wire_stroke,       scalar, RND_CFN_LIST,    "editor/style",           "tool_wire_stroke",       "pen preference for the wire tool; pick the first existing pen or if none existing the first item", 0)
conf_reg(editor.style.tool_rect_stroke,       scalar, RND_CFN_LIST,    "editor/style",           "tool_rect_stroke",       "pen preference for the rectangle tool; pick the first existing pen or if none existing the first item; used only if tool_rect_has_pen is true", 0)
conf_reg(editor.style.tool_rect_has_stroke,   scalar, RND_CFN_BOOLEAN, "editor/style",           "tool_rect_has_stroke",   "whether to stroke (use the pen to draw the outline)", 0)
conf_reg(editor.style.tool_rect_has_fill,     scalar, RND_CFN_BOOLEAN, "editor/style",           "tool_rect_has_fill",     "whether to fill (draw a filled polyogn using the fill color)", 0)
conf_reg(editor.style.tool_rect_fill,         scalar, RND_CFN_LIST,    "editor/style",           "tool_rect_fill",         "polygon fill color; used only if tool_rect_has_fill is true", 0)
conf_reg(editor.default_font.family,          scalar, RND_CFN_STRING,  "editor/default_font",    "family",                 "if pen font is not found, search for a fallbakc font using this font family", 0)
conf_reg(editor.default_font.style,           scalar, RND_CFN_STRING,  "editor/default_font",    "style",                  "if pen font is not found, search for a fallbakc font using this font style", 0)
conf_reg(appearance.color.attached,           scalar, RND_CFN_COLOR,   "appearance/color",       "attached",               "<attached>", 0)
conf_reg(appearance.color.selected_stroke,    scalar, RND_CFN_COLOR,   "appearance/color",       "selected_stroke",        "<selected_stroke>", 0)
conf_reg(appearance.color.selected_fill,      scalar, RND_CFN_COLOR,   "appearance/color",       "selected_fill",          "<selected_fill>", 0)
conf_reg(appearance.color.connection_good,    scalar, RND_CFN_COLOR,   "appearance/color",       "connection_good",        "<connection_good>", 0)
conf_reg(appearance.color.connection_bad,     scalar, RND_CFN_COLOR,   "appearance/color",       "connection_bad",         "<connection_bad>", 0)
conf_reg(appearance.color.hilight_stroke,     scalar, RND_CFN_COLOR,   "appearance/color",       "hilight_stroke",         "<hilight_stroke>", 0)
conf_reg(appearance.color.symbol_meta_embed,  scalar, RND_CFN_COLOR,   "appearance/color",       "symbol_meta_embed",      "symbol meta bounding box and info text draw color for group objects", 0)
conf_reg(appearance.color.symbol_meta_loclib, scalar, RND_CFN_COLOR,   "appearance/color",       "symbol_meta_loclib",     "symbol meta bounding box and info text draw color for group refs to local lib", 0)
conf_reg(appearance.color.non_graphical_background, scalar, RND_CFN_COLOR,   "appearance/color",       "non_graphical_background", "color of non-graphical sheet background", 0)
conf_reg(appearance.color.non_graphical_text, scalar, RND_CFN_COLOR,   "appearance/color",       "non_graphical_text",     "color of non-graphical sheet text", 0)
conf_reg(compile.multiport_net_merge,         scalar, RND_CFN_BOOLEAN, "compile",                "multiport_net_merge",    "when multiple ports with the same component:port name connect to different nets: if true, allow merging those nets, else throw an error", 0)
conf_reg(compile.views,                       scalar, RND_CFN_HLIST,   "compile",                "views",                  "<views>", 0)
conf_reg(compile.hierarchic.net_allow_rename, scalar, RND_CFN_BOOLEAN, "compile/hierarchic",     "net_allow_rename",       "When false: throw an error if a network is named on both parent and child side of a hierarchic descend; otherwise use net_rename_prefer_top to decide which name to keep; best place to set this is the project role.", 0)
conf_reg(compile.hierarchic.net_rename_prefer_top, scalar, RND_CFN_BOOLEAN, "compile/hierarchic",     "net_rename_prefer_top",  "If net_allow_rename==true, this decides whether to prefer parent (top) sheet's net name (true) or child (bottom) sheet's net name (false) when merging the two nets; best place to set this is the project role.", 0)
conf_reg(prj.root_sheets,                     scalar, RND_CFN_LIST,    "prj",                    "root_sheets",            "when non-empty, it lists all root sheets that are part of the project; each root sheet is the root of a hierarchy (may be a single sheet hierarchy, tho)", 0)
conf_reg(prj.aux_sheets,                      scalar, RND_CFN_LIST,    "prj",                    "aux_sheets",             "when non-empty, it lists all non-root sheets that can be referenced by root sheets or other aux sheets in a hierarchy", 0)
conf_reg(stance.model,                        scalar, RND_CFN_STRING,  "stance",                 "model",                  "model type (within the product family) to build: current value", 0)
conf_reg(stance.model_values,                 scalar, RND_CFN_LIST,    "stance",                 "model_values",           "model type: possible values", 0)
conf_reg(stance.sub_major,                    scalar, RND_CFN_STRING,  "stance",                 "sub_major",              "major subtype property: current value", 0)
conf_reg(stance.sub_major_values,             scalar, RND_CFN_LIST,    "stance",                 "sub_major_values",       "major subtype: possible values", 0)
conf_reg(stance.sub_minor,                    scalar, RND_CFN_STRING,  "stance",                 "sub_minor",              "minor subtype property: current value", 0)
conf_reg(stance.sub_minor_values,             scalar, RND_CFN_LIST,    "stance",                 "sub_minor_values",       "minor subtype: possible values", 0)
conf_reg(stance.test_bench,                   scalar, RND_CFN_STRING,  "stance",                 "test_bench",             "which test bench to use, e.g. for simulation", 0)
conf_reg(stance.test_bench_values,            scalar, RND_CFN_LIST,    "stance",                 "test_bench_values",      "test bench: possible values", 0)
